### Method

# FwupdPlugin Device dump_firmware

#### Declaration [src]

    GBytes*
    fu_device_dump_firmware (
      FuDevice* self,
      FuProgress* progress,
      GError** error
    )

#### Description [src]

Reads the raw firmware image from the device by calling a plugin-specific vfunc. This raw firmware image may contain serial numbers or device-specific configuration but should be a byte-for-byte match compared to using an external SPI programmer.

Available since: | 1.5.0

#### Parameters

`progress` | `FuProgress`
| A `FuProgress`.
| The data is owned by the caller of the function.
`error` | `GError **`
| The return location for a `GError*`, or `NULL`.

#### Return value

Returns: | `GBytes`
| A `GBytes`, or `NULL` for error.
| The caller of the method takes ownership of the data, and is responsible for freeing it.